Ext.namespace("dSA", "dSA.functions");

dSA.functions.ReregisterDevices = function(dsid)
{
    Ext.Ajax.request(
    {
        url: '/dsa/json/dsm/restartRegistration',
        disableCaching: true,
        method: 'GET',
        params: { dsid : dsid },
        failure: function(response, opts)
        {
            Ext.Msg.alert(dSA._("Error"),
                          dSA._("Could not reregister devices") +
                          dSA.util.colon(dSA.util.failureMessage(response)));
        }
    });
};

// callback(success, task_id)
dSA.functions.CheckTransmissionQuality = function(dsid, checksPerDevice,
                                                  callback)
{
    Ext.Ajax.request(
    {
        url: '/dsa/json/hardware/testDeviceTransmissionQuality',
        disableCaching: true,
        method: 'GET',
        params:
        {
            dsm : dsid,
            checksPerDevice: checksPerDevice
        },
        success: function(response, opts)
        {
            try
            {
                var data = dSA.util.getData(response);
                if (data.task === undefined)
                {
                    throw "received invalid task id";
                }

                if (callback !== undefined)
                {
                    callback(true, data.task);
                }
            }
            catch (error)
            {
                Ext.Msg.alert(dSA._("Error"),
                    dSA._("Could not start transmission quality test") +
                    dSA.util.colon(error));
                if (callback !== undefined)
                {
                    callback(false);
                }
            }
        },
        failure: function(response, opts)
        {
            Ext.Msg.alert(dSA._("Error"),
                          dSA._("Could not start transmission quality test") +
                          dSA.util.colon(dSA.util.failureMessage(response)));
            if (callback !== undefined)
            {
                callback(false);
            }
        }
    });

};

// callback(taskObject)
dSA.functions.getTaskResultSummary = function(taskID, callback)
{
    Ext.Ajax.request(
    {
        url: '/dsa/json/tasks/resultSummary',
        disableCaching: true,
        method: 'GET',
        params:
        {
            id : taskID
        },
        success: function(response, opts)
        {
            try
            {
                var data = dSA.util.getData(response);
                if (data.task === undefined)
                {
                    throw "received unexpected reply";
                }

                if (callback !== undefined)
                {
                    callback(true, data.task);
                }
            }
            catch (error)
            {
                Ext.Msg.alert(dSA._("Error"),
                    dSA._("Could not retrieve task summary") +
                    dSA.util.colon(error));
                if (callback !== undefined)
                {
                    callback(false);
                }
            }
        },
        failure: function(response, opts)
        {
            Ext.Msg.alert(dSA._("Error"),
                          dSA._("Could not retrieve task summary") +
                          dSA.util.colon(dSA.util.failureMessage(response)));
            if (callback !== undefined)
            {
                callback(false);
            }
        }
    });

};

