Ext.namespace('dSA', 'dSA.util');

dSA.util.shortDSID = function(dsid) {
    if (dsid.length > 8) {
        return dsid.slice(dsid.length - 8);
    } else {
        return dsid;
    }
};

dSA.util.getName = function(name) {
    if ((name === undefined) || (name.length === 0)) {
        return '<i>' + dSA._("no name") + '</i>';
    } else {
        return name;
    }
};

dSA.util.getData = function(response)
{
    var json = Ext.util.JSON.decode(response.responseText);
    if (json.success === false)
    {
        throw json.message;
    }

    if (json.data === undefined)
    {
        throw _("could not retrieve data from response");
    }
    return json.data;
};

dSA.util.failureMessage = function(response)
{
    try 
    {
        var json = Ext.util.JSON.decode(response.responseText);
        if (json.message)
        {
            return json.message;
        }
    }
    catch (error)
    {
        // when the dSA is not running lighttpds proxy will return an
        // HTTP 500 along with some HTML which will cause a JSON parsing error
        return ""; 
    }
};

dSA.util.colon = function(text)
{
    return text === "" ? text : ": " + text;
};
